#include <unistd.h>

#include "system.h"
#include "field.h"
#include "keys.h"
#include "io.h"

systeemi::systeemi() : sele(8), changed(false)
{
   	for(unsigned y=0; y<20; ++y)
   	{
   		unsigned base = y+2;
   		if(base > 10)base += 1;
   		if(base > 12)base += base / 7;
   		if(base > 16)base = base*2 - 14;
   		if(base < 36 && base >= 20)base -= 2;
   		inputs[y] = new inputfield(2, 2 + y, 31, base);
   	}
}

void systeemi::idlet()
{
	unsigned tick=0;
	for(;;)
	{
		for(unsigned y=0; y<20; ++y)
		{
			inputfield *tmp = (inputfield *)inputs[y];
			
			tmp->selected = y==sele;
			tmp->draw(tick);
		}				
		if(kbhit())break;
		UpdateVideo(1);
		usleep(20000);
		if(++tick==40)
		{
			tick=20;
		}
		if(tick==5 && changed)
		{
			laske();
			changed = false;
		}
	}
}

void systeemi::laske(bool kaikki)
{
	inputfield *tmp2 = (inputfield *)inputs[sele];
	
	for(unsigned y=0; y<20; ++y)
		if(y != sele || kaikki)
		{
			inputfield *tmp = (inputfield *)inputs[y];
			
			tmp->laske(tmp2->content, tmp2->base);
			tmp->key(kbhome);
		}
}

void systeemi::key(int c)
{
	if(c == kbup)
	{
		if(sele > 0)sele--;
	}
	else if(c == kbdn)
	{
		if(sele < 19)sele++;
	}
	else if(c == kbpgup)
		sele = 0;
	else if(c == kbpgdn)
		sele = 19;
	else if(c == kbenter)
		laske(true);
	else
	{
		inputfield *tmp = (inputfield *)inputs[sele];
		tmp->key(c);
		if(c >= ' ' || c == kbback || c == kbdel || c == '')
			changed = true;
	}
}

void systeemi::run()
{
	for(;;)
	{
		idlet();
		
		int c = getkey();
		if(c == kbesc)break;
		
		key(c);
	}	
}
